unit GrabConsole;

interface

uses
    Forms, Windows, SysUtils, Classes;

procedure   PipeConsole(CommandLine: string; StdOut, ErrOut: TStrings);

implementation

(*
    =================================================================
    [2004/03/19]
    -----------------------------------------------------------------
    [Delphi] GUI AvR\[Avsɂ
    http://hp.vector.co.jp/authors/VA026252/tips/delphi_anonymous_pipe.html
    =================================================================
*)
procedure   PipeConsole(CommandLine: string; StdOut, ErrOut: TStrings);
var
    hReadPipe, hWritePipe: THandle;
    hStdInReadPipe, hStdInWritePipe, hStdInWritePipeDup: THandle;
    hErrReadPipe, hErrWritePipe: THandle;
    sa: TSecurityAttributes;
    StartupInfo: TStartupInfo;
    ProcessInfo: TProcessInformation;
    dwStdOut, dwErrOut, dwRet: DWord;
    Buf: array[0..8192] of Char;
begin

    with sa do
    begin
        nLength              := sizeof(TSecurityAttributes);
        lpSecurityDescriptor := nil;
        bInheritHandle       := true;
    end;
    hReadPipe     := 0;
    hWritePipe    := 0;
    hErrReadPipe  := 0;
    hErrWritePipe := 0;

    CreatePipe(hStdInReadPipe, hStdInWritePipe, @sa, 8192);
    DuplicateHandle(GetCurrentProcess(), hStdInWritePipe, GetCurrentProcess(),
                    @hStdInWritePipeDup, 0, false, DUPLICATE_SAME_ACCESS);
    CloseHandle(hStdInWritePipe);

    CreatePipe(hReadPipe, hWritePipe, @sa, 8192);
    try
        CreatePipe(hErrReadPipe, hErrWritePipe, @sa, 8192);
        try
            ZeroMemory(@StartupInfo, sizeof(TStartupInfo));
            with StartupInfo do
            begin
                cb := sizeof(TStartupInfo);
                dwFlags := STARTF_USESTDHANDLES;
                // ꂪȂ DOS \Ă܂
                wShowWindow := SW_HIDE;
                // W IO ɃpCv̒[w肵Ă
                hStdInput  := hStdInReadPipe;
                hStdOutput := hWritePipe;
                hStdError  := hErrWritePipe;
            end;

            // R\[AvN
            if CreateProcess(nil, PChar(CommandLine), @sa, nil, true, DETACHED_PROCESS,
                             nil, nil, StartupInfo, ProcessInfo) then
            begin
                try
                    repeat
                        Application.ProcessMessages;
                        Sleep(50);

                        // Wo̓pCv̓e𒲂ׂ
                        PeekNamedPipe(hReadPipe, nil, 0, nil, @dwStdOut, nil);
                        // e݂΁Aǂݎ
                        if (dwStdOut > 0) then
                        begin
                            FillChar(Buf, SizeOf(Buf), 0);
                            ReadFile(hReadPipe, Buf, SizeOf(Buf) - 1, dwStdOut, nil);
                            StdOut.Add(Trim(Buf));
                        end;

                        // lɃG[o͂̏
                        PeekNamedPipe(hErrReadPipe, nil, 0, nil, @dwErrOut, nil);
                        // e݂΁Aǂݎ
                        if (dwErrOut > 0) then
                        begin
                            FillChar(Buf, SizeOf(Buf), 0);
                            ReadFile(hErrReadPipe, Buf, SizeOf(Buf) - 1, dwErrOut, nil);
                            ErrOut.Add(Trim(Buf));
                        end;

                        dwRet := WaitForSingleObject(ProcessInfo.hProcess, 0);
                    // R\[AṽvZX݂Ă
                    until
                        (dwRet = WAIT_OBJECT_0);
                finally
                    CloseHandle(ProcessInfo.hProcess);
                    CloseHandle(ProcessInfo.hThread);
                    CloseHandle(hStdInReadPipe);
                end;
            end;
        finally
            CloseHandle(hErrReadPipe);
            CloseHandle(hErrWritePipe);
        end;
    finally
        CloseHandle(hReadPipe);
        CloseHandle(hWritePipe);
    end;
end;

end.

