(*
    ============================================================================
    [2004/04/06]    WinApi              Windows API
                    PShell              Poor Shell
    [2004/04/05]    TFormCustomizer
    [2004/04/03]    MBox                MessageBox
    ============================================================================
*)

//------------------------------------------------------------------------------
unit fjutil;
//------------------------------------------------------------------------------
interface
//------------------------------------------------------------------------------
uses
    Windows, SysUtils, Forms, ShellAPI, ShlObj, ActiveX, ComObj, Math;

//------------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------
type
    WinApi = class
    public
        class function IsKeyDown(const K: Word): Boolean;
        class function GetTempFile(const Extension: string): string;      overload;
        class function GetTempFile(const Dir, Extension: string): string; overload;
        class function FileSize(const Path: string): integer;
        class function MoveFile(const Src, Dst: string): Boolean;
    end;

//------------------------------------------------------------------------------
//  VFn̂₱z
//------------------------------------------------------------------------------
type
    TClassID =
    (
        idDesktop    = CSIDL_DESKTOP,          //  fXNgbv
        idDesktopDir = CSIDL_DESKTOPDIRECTORY, //  fXNgbv
        idPersonal   = CSIDL_PERSONAL,         //  }ChLg
        idCookies    = CSIDL_COOKIES,          //  NbL[
        idFavorites  = CSIDL_FAVORITES,        //  Cɓ
        idFonts      = CSIDL_FONTS,            //  tHg
        idHistory    = CSIDL_HISTORY,          //  
        idCache      = CSIDL_INTERNET_CACHE,   //  C^[lbg̃LbV
        idPrograms   = CSIDL_PROGRAMS,         //  vO
        idRecent     = CSIDL_RECENT,           //  ŋߎgt@C
        idSendTo     = CSIDL_SENDTO,           //  
        idStartMenu  = CSIDL_STARTMENU,        //  X^[gj[
        idStartup    = CSIDL_STARTUP,          //  X^[gAbv
        idTemplates  = CSIDL_TEMPLATES         //  ev[g
    );

    PShell = class
    public
        class function GetSpecialFolder(const nFolder: TClassID): string;
        class function CreateShortCut(const FileName, Args, WorkDir, DestPath: string): Boolean;
        class function ShellExecute(const FileName, Params: string): Boolean;
        class function SelectDirectoryEx(Owner: TForm; const Caption: string;
                        const Root: string; var Directory: string): Boolean;
    end;

//------------------------------------------------------------------------------
//  tH[ƂNX
//------------------------------------------------------------------------------
type
    TFormCustomizer = class
    public
        constructor Create();
        //  LvVȂ
        procedure   SetCaption(F: TForm);
    end;

//------------------------------------------------------------------------------
//  bZ[W{bNX\pNX
//  TApplication.MessageBox()  Flag G炸 Windows.MessageBox ɓnƂ
//  OƂƗEڐA̔؂Ȏ
//------------------------------------------------------------------------------
type
    MBox = class
    private
        class function _MessageBox(const S: string; const F: integer): integer;
        class function _MessageBoxEx(const S: string; const F: integer;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
    public
        //  Information{bNX
        class procedure InfoOk(const S: string; const IsSysTop: Boolean = false);
        //  Warning{bNX
        class procedure WarnOk(const S: string; const IsSysTop: Boolean = false);
        //  Error{bNX
        class procedure ErrorOk(const S: string; const IsSysTop: Boolean = false);
        //  Ok/Cancel{bNX
        class function OkCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
        //  Yes/No{bNX
        class function YesNo(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
        //  Yes/No/Cancel{bNX
        class function YesNoCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
    end;

//------------------------------------------------------------------------------
var
    FBox: TFormCustomizer;
//------------------------------------------------------------------------------

implementation

(*
    ============================================================================
    TWinApi
    ============================================================================
*)

//------------------------------------------------------------------------------
//  t@Cړ
class function WinApi.MoveFile(const Src, Dst: string): Boolean;
begin
    Result := Windows.MoveFile(PChar(Src), PChar(Dst));
end;

(*
    ============================================================================
    http://www.wwlnk.com/boheme/delphi/tips/tec0060.htm
    ----------------------------------------------------------------------------
    [2004/04/06]t@CTCY擾
    ============================================================================
*)
class function WinApi.FileSize(const Path: string): integer;
var
    Rec: TSearchRec;
begin
    Result := 0;
    if  FindFirst(Path, faAnyFile, Rec) = 0 then
    begin
        Result :=  Rec.Size;
    end;
    FindClose(Rec);
end;

(*
    ============================================================================
    http://www.mesuttop.com/delphi/tip_files.htm
    ----------------------------------------------------------------------------
    [2004/04/06]Using GetTempFileName to create a unique temporary file
    ============================================================================
*)
class function WinApi.GetTempFile(const Extension: string): string;
var
    Buffer: array[0..MAX_PATH] of char;
begin
    GetTempPath(Sizeof(Buffer) - 1, Buffer);
    GetTempFileName(Buffer, PChar(Extension), 0, Buffer);
    Result := String(Buffer);
end;

class function WinApi.GetTempFile(const Dir, Extension: string): string;
var
    Buffer: array[0..MAX_PATH] of char;
begin
    GetTempFileName(PChar(Dir), PChar(Extension), 0, Buffer);
    Result := String(Buffer);
end;
(*
    ============================================================================
    http://forum.nifty.com/fdelphi/samples/00782.html
    ----------------------------------------------------------------------------
    [2004/04/06]"ESCL[Ń[vf"
    ============================================================================
*)
class function WinApi.IsKeyDown(const K: Word): Boolean;
begin
    Result := (GetAsyncKeyState(K) <> 0);
end;

(*
    ============================================================================
    TPoorShell
    ============================================================================
*)

(*
    ============================================================================
    http://forum.nifty.com/fdelphi/samples/01269.html
    ----------------------------------------------------------------------------
    [2004/04/08]ǔSelectDirectory@\_E
    ============================================================================
*)
function BrowseFolderProc(hWindow: HWND; uMsg: UINT; lParam: LPARAM;
                                            lpData: LPARAM): Integer; stdcall;
var
    PathName: array[0..MAX_PATH] of Char;
begin
    case uMsg of
    BFFM_INITIALIZED:
        begin
            SendMessage(hWindow, BFFM_SETSELECTION, WPARAM(True), lpData);
        end;
    BFFM_SELCHANGED:
        begin
            SHGetPathFromIDList(PItemIDList(lParam), @PathName);
            SendMessage(hWindow, BFFM_SETSTATUSTEXT, 0, LongInt(PChar(@PathName)));
        end;
    end;
    Result := 0;
end;

class function PShell.SelectDirectoryEx(Owner: TForm; const Caption: string;
                const Root: string; var Directory: string): Boolean;
var
    IDList: PItemIDList;
    BI: TBrowseInfo;
    Malloc:IMalloc;
    WindowList: Pointer;
    Buffer: PChar;
begin
    Result := False;
    Directory := '';
    FillChar(BI, SizeOf(BI), 0);
    if (ShGetMalloc(Malloc) = S_OK) and (Malloc <> nil) then
    begin
        Buffer := Malloc.Alloc(MAX_PATH);
        try
            BI.hwndOwner      := Owner.Handle;
            BI.pidlRoot       := nil;
            BI.pszDisplayName := Buffer;
            BI.lpszTitle      := PChar(Caption);
            BI.ulFlags        := BIF_STATUSTEXT or BIF_RETURNONLYFSDIRS;
            BI.lpfn           := @BrowseFolderProc;
            BI.lParam         := integer(PChar(Root));

            WindowList := DisableTaskWindows(0);
            try
                IDList := ShBrowseForFolder(BI);
            finally
                EnableTaskWindows(WindowList);
            end;

            Result := (IDList <> nil);
            if Result then
            begin
                ShGetPathFromIDList(IDList, Buffer);
                Malloc.Free(IDList);
                Directory := Buffer;
            end;
        finally
            Malloc.Free(Buffer);
        end;
    end;
end;

//------------------------------------------------------------------------------
//  ShellExecute
class function PShell.ShellExecute(const FileName, Params: string): Boolean;
const
    ERROR_NO = 32;
var
    Value: integer;
begin
    Value := ShellApi.ShellExecute(0, 'open', PChar(FileName), PChar(Params), nil, SW_SHOWDEFAULT);
    Result := (Value > ERROR_NO);
end;

(*
    ============================================================================
    http://i749.obi.ne.jp/kazina/html/memo/delphi/getspecialfolder.html
    ----------------------------------------------------------------------------
    [2004/04/05]VXetH_擾
    ============================================================================
*)
class function PShell.GetSpecialFolder(const nFolder: TClassID): string;
var
    pidl: PItemIDList;
    Buffer: array[0..MAX_PATH] of Char;
begin
    SHGetSpecialFolderLocation(0, Ord(nFolder), pidl);
    SHGetPathFromIDList(pidl, Buffer);
    Result := Buffer;
end;

(*
    ============================================================================
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    ----------------------------------------------------------------------------
    [2004/04/05]X^[gAbvɃV[gJbg쐬
    ============================================================================
*)
class function PShell.CreateShortCut(const FileName, Args, WorkDir, DestPath: string): Boolean;
var
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    LinkFileName: string;
    WFileName: WideString;
begin
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink:= CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile:= ShellLink as IPersistFile;
    //  ݒ
    with ShellLink do
    begin
        //  t@ČɎw肷p[^(prs)
        SetArguments(PChar(Args));
        //  Nt@C̃tpX
        SetPath(PChar(FileName));
        //  ƃtH_
        SetWorkingDirectory(PChar(WorkDir));
    end;
    //  V[gJbgt@C̃pX
    LinkFileName := ChangeFileExt(ExtractFilename(FileName),'.lnk'); 
    LinkFileName := Format('%s\%s', [DestPath, LinkFileName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), false));
    //  ǂłH
    Result := FileExists(LinkFileName);
end;

(*
    ============================================================================
    TFormCustomizer
    ============================================================================
*)

//------------------------------------------------------------------------------
constructor TFormCustomizer.Create();
begin
    //
end;

//------------------------------------------------------------------------------
procedure   TFormCustomizer.SetCaption(F: TForm);
begin
    F.Caption := Format('%s - %s', [ChangeFileExt(ExtractFileName(ParamStr(0)), ''), F.Caption]);
end;

(*
    ============================================================================
    TMessageBox
    ============================================================================
*)

//------------------------------------------------------------------------------
class function MBox._MessageBox(const S: string; const F: integer): integer;
begin
    Application.BringToFront();
    Result := Application.MessageBox(PChar(S), PChar(Application.Title), F);
end;
//------------------------------------------------------------------------------
class function MBox._MessageBoxEx(const S: string; const F: integer;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var _F: integer;
begin
    _F := F;
    if IsSysTop then _F := _F + MB_TOPMOST;
    case DefBtnNo of
    2: _F := _F + MB_DEFBUTTON2;
    3: _F := _F + MB_DEFBUTTON3;
    4: _F := _F + MB_DEFBUTTON4;
    end;
    Result := _MessageBox(S, _F);
end;
//------------------------------------------------------------------------------
class procedure MBox.InfoOk(const S: string;const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONINFORMATION;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
class procedure MBox.WarnOk(const S: string; const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONWARNING;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
class procedure MBox.ErrorOk(const S: string; const IsSysTop: Boolean = false);
var F: integer;
begin
    F := MB_OK + MB_ICONERROR;
    _MessageBoxEx(S, F, 1, IsSysTop);
end;
//------------------------------------------------------------------------------
class function MBox.OkCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_OKCANCEL + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
class function MBox.YesNo(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_YESNO + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
class function MBox.YesNoCancel(const S: string;
                                const DefBtnNo: integer = 1;
                                const IsSysTop: Boolean = false): integer;
var F: integer;
begin
    F := MB_YESNOCANCEL + MB_ICONQUESTION;
    Result := _MessageBoxEx(S, F DefBtnNo, IsSysTop,);
end;
//------------------------------------------------------------------------------
initialization
    FBox := TFormCustomizer.Create;
finalization
    FBox.Free;
//------------------------------------------------------------------------------
end.

